var React    = require("react");
var CloseButton  = require("./button.react.jsx");

var cssStyle  = require("./assets/css/dialog.react.css");

var Dialog = React.createClass({

	getDefaultProps:(function(){
		return {visible:true};
	}),
	getInitialState:(function(){

		return {closeLeft:null, closeTop:null};

	}),


	render:(function(){
		var ismodal  = (typeof this.props.modal=='boolean')?this.props.modal:false;

		var style = Object.assign({
			boxShadow:"0px 1px 2px 1px rgba(0,0,0,0.2)",
			"borderRadius":"1px",
			"position":"relative",
			"margin":"0px",
			modal:{
				position:(ismodal==true)?"fixed":"relative",				
				"overflow":"hidden",
				"margin":"0px",		
				"width":(ismodal)?"99.8%":"auto",
				"height":(ismodal)?"100%":"auto",
				"backgroundColor":(!ismodal)?"transparent":"",
				"padding":"2px",
				"display":(this.props.visible)?"block":"none",
				"visibility":(this.props.visible)?"visible":"hidden",
			
			},
			closeButton:{
				boxShadow:"0px 1px 2px 0px rgba(0,0,0,0.2)",
				"borderRadius":"75px",
				"padding":"2px",
				"display":(this.props.enableCloseButton)?"block":"none",
				"visibility":(this.props.enableCloseButton)?"visible":"hidden",
				left:(this.state.closeLeft)?this.state.closeLeft:"auto",
				"top":(this.state.closeTop)?this.state.closeTop:"auto",
				"zIndex":987689,
							

			}
		}, this.props.style);
		var className =cssStyle.dialog+ " "+(this.props.className || "");
		return (
			<div style={style.modal} 
				 className ={cssStyle.modal} 
				 ref='modal' 
				 onClick={__doubleClick.bind(this)}>

			    <CloseButton   ref='close'  className ={cssStyle.close} 
			    style={style.closeButton} 
			    onClick={__onClose.bind(this)} />
				<div className={className}  style={style} ref='content' >
				  {this.props.children|| null}
				</div>

			</div>

			)

	})
});


Dialog.prototype.componentDidMount =(function(){
	__doLayout.call(this);	


});

Dialog.propTypes ={
	modal:React.PropTypes.bool,
	onSelect:React.PropTypes.func,

}

Dialog.prototype.componentDidUpdate =(function(preState, preProps){
	__doLayout.call(this);

});


var __doLayout  =(function(){
	var modal = this.refs.modal;
	if(modal){
		if(this.props.fillParent){
		 var parentNode  = modal.parentNode;
		 if(!parentNode)parentNode= window.document.body;
		 var rectParent  = parentNode.getBoundingClientRect();
		 modal.style.width =rectParent.width+"px";
		 modal.style.left  = rectParent.left+"px";
		 modal.style.top   = rectParent.top +"px";
		}
	    __center.call(this);
	    __layoutCloseButton.call(this)	  
	}
})



var __layoutCloseButton  =(function(){
	    var content  = this.refs.content;
	    var rect  = content.getBoundingClientRect();
	    var right = (rect.width + rect.left)-25;
	    var top   = rect.top-(20);
	    if(top <=0){
	    	  top  +=20;
	    	  content.style.top= top+"px";
	    	  top  = top-20;
	    }
	    this.setState({closeTop:top, closeLeft:right});
})
/**
*/

var __center=(function(){
	var modal    = this.refs.modal;
	var content  = this.refs.content;
	var rect  = modal.getBoundingClientRect();
	var isCenterX  = (this.props.center || this.props.centerX || false);
	var isCenterY  = (this.props.center || this.props.centerY || false);
	if(isCenterX==true)
      __centerX.call(this, rect);
    if(isCenterY==true)
      __centerY.call(this, rect);
});


var __centerX  = (function(rect){
	var content  = this.refs.content;
	var rectContent  = content.getBoundingClientRect();  
	var xPos  = (rect.width *0.5) -(rectContent.width *0.5) + rect.left;
	content.style.left = parseInt(xPos)+"px";
});

var __centerY  = (function(rect){
	var content  = this.refs.content;
	var rectContent  = content.getBoundingClientRect();  
	var yPos  = (rect.height *0.5) -(rectContent.height *0.5) + rect.top;
	content.style.top = parseInt(yPos)+"px";
});


var __doubleClick =(function(event){
	  var event  = event || window.event;
	  if(event){
	  	event.preventDefault();
	  	  if(this.props.onSelect){
	  	  	  this.props.onSelect(this, event);
	  	  }

	  }
})


var __onClose  =(function(){
	if(this.props.onClose){
		 this.props.onClose();
	}
});


var __mouseOverClose  =(function(){

   this.setState({hover:true});
})


var __mouseLeaveClose  =(function(){
 this.setState({hover:false});
	
})


Dialog.Button  = CloseButton;
module.exports  = Dialog;